/*********************************************************
## This file is part of Prodog.  All files in the distribution of Prodog
## are Copyright 2000 by
##
##     Alva L.  Couch,
##     Associate Professor of Computer Science,
##     Tufts University, Medford MA 02155
##     email: couch@eecs.tufts.edu
##     phone: 617-627-3674
##
## All rights reserved.
##
## Redistribution, modification, and use are permitted provided that this 
## entire copyright notice is duplicated in all such copies, and that any
## documentation, announcements, and other materials related to such
## distribution and use acknowledge that the software was developed by
## Alva L.  Couch at Tufts University in Medford, Massachusetts, USA.
## No charge, other than an "at-cost" distribution fee, may be charged
## for copies, derivations, or distributions of this material without
## the express written consent of the copyright holder.  Neither the
## name of the University nor the names of the authors may be used to
## endorse or promote products derived from this material without
## specific prior written permission.  THIS SOFTWARE IS PROVIDED ``AS
## IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
## WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
## FITNESS FOR ANY PARTICULAR PURPOSE.
 *********************************************************/
/*  Include file depends on local installation */
#include <SWI-Prolog.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <fcntl.h> 
#include <sys/wait.h> 

/* this function strips a field, space padded, from a line of input. */ 

foreign_t 
pl_field(term_t line, term_t begin, term_t end, 
         term_t output, foreign_t handle) 
{ 
  char *line_val; 
  char buf[1024]; 
  int begin_val, end_val; 
  char *p, *q; 
  int size; 

  /* get parameters */ 
  if (!PL_get_atom_chars(line,&line_val)) PL_fail; 
  if (!PL_get_integer(begin,&begin_val)) PL_fail; 
  if (!PL_get_integer(end,&end_val)) PL_fail; 
  
  strcpy(buf,line_val); 
  size=strlen(buf); 
  if (begin_val<0) p=buf; else p=buf+begin_val; 
  if (end_val<0) q=buf+size-1; else q=buf+end_val;   
  while (p<q && (*p==' ' || *p=='\t' || *p=='\n')) p++; 
  while (p<q && (*q==' ' || *q=='\t' || *q=='\n')) q--; 
  *(q+1)='\0'; 
  if (PL_unify_atom_chars(output,p)) PL_succeed; 
  else PL_fail; 
} 

install_t
pl_field_install()
{ 
  PL_register_foreign("field", 4, pl_field, 0);
}
