/*********************************************************
## This file is part of Prodog.  All files in the distribution of Prodog
## are Copyright 2000 by
##
##     Alva L.  Couch,
##     Associate Professor of Computer Science,
##     Tufts University, Medford MA 02155
##     email: couch@eecs.tufts.edu
##     phone: 617-627-3674
##
## All rights reserved.
##
## Redistribution, modification, and use are permitted provided that this 
## entire copyright notice is duplicated in all such copies, and that any
## documentation, announcements, and other materials related to such
## distribution and use acknowledge that the software was developed by
## Alva L.  Couch at Tufts University in Medford, Massachusetts, USA.
## No charge, other than an "at-cost" distribution fee, may be charged
## for copies, derivations, or distributions of this material without
## the express written consent of the copyright holder.  Neither the
## name of the University nor the names of the authors may be used to
## endorse or promote products derived from this material without
## specific prior written permission.  THIS SOFTWARE IS PROVIDED ``AS
## IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
## WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
## FITNESS FOR ANY PARTICULAR PURPOSE.
 *********************************************************/
/*  Include file depends on local installation */
#include <SWI-Prolog.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h> 
#include <fcntl.h> 
#include <sys/wait.h> 

/* this program deletes lines matching a pattern from a file */ 

foreign_t 
pl_sys_appendIfNoSuchLine(term_t path, term_t pattern) 
{ 
  char *path_val; 
  char *pattern_val; 
  char buf[256]; 
  char pat[256]; 
  FILE *in; 
  FILE *out; 
  struct stat statbuf; 
  int i; 

  /* get parameters */ 
  if (!PL_get_atom_chars(path,&path_val)) PL_fail; 
  if (!PL_get_atom_chars(pattern,&pattern_val)) PL_fail; 
  /* if (path[0]!="/") PL_fail; */ 
  if (stat(path_val,&statbuf)) PL_fail; 
  /* check that it's a regular file */ 
  if ((statbuf.st_mode&S_IFMT)!=S_IFREG) PL_fail; 
  /* check that we can read it */ 
  if (!(in = fopen(path_val,"r"))) PL_fail; 
  strcpy(pat,pattern_val); 
  i = strlen(pat)-1; 
  if (pat[i]=='\n') pat[i]=0; 
  while (!feof(in)) { 
    fgets(buf,256,in); 
    i = strlen(buf)-1; 
    if (buf[i]=='\n') buf[i]=0; 
    if (strcmp(buf,pat)==0) { 
      fclose(in); 
      PL_succeed; 
    } 
  } 
  fclose(in); 
  if (!(out=fopen(path_val,"a"))) PL_fail; 
  fprintf(out,"%s\n",pat); 
  fclose(out); 
  PL_succeed; 
  PL_succeed; 
} 

install_t
pl_sys_appendIfNoSuchLine_install()
{ 
  PL_register_foreign("sys_appendIfNoSuchLine", 2, pl_sys_appendIfNoSuchLine, 0);
}
