/*********************************************************
## This file is part of Prodog.  All files in the distribution of Prodog
## are Copyright 2000 by
##
##     Alva L.  Couch,
##     Associate Professor of Computer Science,
##     Tufts University, Medford MA 02155
##     email: couch@eecs.tufts.edu
##     phone: 617-627-3674
##
## All rights reserved.
##
## Redistribution, modification, and use are permitted provided that this 
## entire copyright notice is duplicated in all such copies, and that any
## documentation, announcements, and other materials related to such
## distribution and use acknowledge that the software was developed by
## Alva L.  Couch at Tufts University in Medford, Massachusetts, USA.
## No charge, other than an "at-cost" distribution fee, may be charged
## for copies, derivations, or distributions of this material without
## the express written consent of the copyright holder.  Neither the
## name of the University nor the names of the authors may be used to
## endorse or promote products derived from this material without
## specific prior written permission.  THIS SOFTWARE IS PROVIDED ``AS
## IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
## WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
## FITNESS FOR ANY PARTICULAR PURPOSE.
 *********************************************************/
/*  Include file depends on local installation */
#include <SWI-Prolog.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/systeminfo.h>

foreign_t 
pl_sysinfo(term_t sysname, 
	   term_t release, 
	   term_t version,
	   term_t machine, 
	   term_t architecture, 
	   term_t isalist, 
	   term_t platform, 
	   term_t provider, 
	   term_t serial, 
	   term_t srpc_domain) 
{ char buf[256]; 
  if (sysinfo(SI_SYSNAME, buf,sizeof(buf))) 
    if (!PL_unify_atom_chars(sysname,buf)) PL_fail; 
  if (sysinfo(SI_RELEASE, buf,sizeof(buf))) 
    if (!PL_unify_atom_chars(release,buf)) PL_fail; 
  if (sysinfo(SI_VERSION, buf,sizeof(buf))) 
    if (!PL_unify_atom_chars(version,buf)) PL_fail; 
  if (sysinfo(SI_MACHINE, buf,sizeof(buf))) 
    if (!PL_unify_atom_chars(machine,buf)) PL_fail; 
  if (sysinfo(SI_ARCHITECTURE, buf,sizeof(buf))) 
    if (!PL_unify_atom_chars(architecture,buf)) PL_fail; 
  if (sysinfo(SI_ISALIST, buf,sizeof(buf))) 
    if (!PL_unify_atom_chars(isalist,buf)) PL_fail; 
  if (sysinfo(SI_PLATFORM, buf,sizeof(buf))) 
    if (!PL_unify_atom_chars(platform,buf)) PL_fail; 
  if (sysinfo(SI_HW_PROVIDER, buf,sizeof(buf))) 
    if (!PL_unify_atom_chars(provider,buf)) PL_fail; 
  if (sysinfo(SI_HW_SERIAL, buf,sizeof(buf))) 
    if (!PL_unify_atom_chars(serial,buf)) PL_fail; 
  if (sysinfo(SI_SRPC_DOMAIN, buf,sizeof(buf))) 
    if (!PL_unify_atom_chars(srpc_domain,buf)) PL_fail; 
  PL_succeed; 
} 

install_t
pl_sysinfo_install()
{ 
  PL_register_foreign("sysinfo", 10, pl_sysinfo, 0);
}
